#/usr/bin/perl
use HTML::Entities ();
<<DOC; 
Axel COURT & Marjorie SEIZOU
FEVRIER 2010

usage : perl Parcours-fils-Grep.pl	chemin-du-repertoire-a-parcourir
 
Le programme prend en entre le nom du rpertoire contenant les fichiers  traiter et demande  l'utilisateur quelle est la rubrique  traiter.
 
Le programme construit en sortie plusieurs fichiers contenant de rsultat du filtrage selon l'usage qui en sera fait :
 - un fichier structur au format XML :
<PARCOURS>
	<DESC>du fichier</DESC> 
	<FILTRAGE rubrique="">
		<FICHIER num="" date="">
			<ARTICLE num="">
				<TITRE>titre de l'article<\/TITRE>   					
				<RESUME>rsum de l'article</RESUME>
			</ARTICLE>						
		</FICHIER>
	</FILTRAGE>
</PARCOURS>

- un fichier texte structur au format de balisage Lexico3 :
<filrss_rubrique=num>
<num_article=num>
<titre_num_article=num>
titre de l'article
<resume_num_article=num>
rsum de l'article
   
- un fichier non structur au format texte ;

- un fichier contenant des balises comme <nom_du_fichier> pour la structuration du tableau des rsultats des tiquetages de TTagger (feuille de style xsl).

- mme chose pour Cordial, mais les reprages ne sont pas sous la forme de balises mais plutt de mots-cls (type "BLOCDEPHRASE"), puisque Cordial s'entte  vouloir
tiqueter chaque lment contenu  l'intrieur d'une balise (contrairement  TT qui n'tiquette pas les balises si l'option -sgml est spcifie)


Remarque : la construction de ce programme s'appuie sur les scripts donns en cours : parcours-arborescence-fichiers.pl, filtreur.pl & nettoyeur.pl

DOC
#-----------------------------------------------------------
########################
# Oprations initiales #
########################

# test des paramtres
if ($ARGV[0] eq "") {
    print " syntaxe : perl parcours-arborescence-fichiers-Grep.pl	chemin_du_repertoire_a_parcourir \n" ;
    exit(-1);
} 

# Rcupration du chemin du rpertoire  parcourir
my $rep="$ARGV[0]";
# on s'assure que le nom du rpertoire ne se termine pas par un "/"
$rep=~ s/[\/]$//;

# Initialisation des diffrentes variables 
# numro & nom de la rubrique, date de l'article trait
my $num="";
my $rubrique="";
my $date="";
# variables contenant le flux de sortie
my $DUMPXML="";
my $DUMPTXT="";
my $DUMPLEXICO="";
my $DUMPTMP=""; # afin d'utiliser des balises '<fichier>' et de structurer le tableau des rsultats
my $DUMPTMP2=""; # idem, mais pour Cordial (on insre des anotations de dbut de fichier)

# dialogue avec l'utilisateur
print "\nBienvenue sur le filtreur-nettoyeur de fils RSS \"Le Monde\" !\n\n";
print "Entrez l'identifiant de la rubrique a traiter : \n";
print "0 : A la une\t\t\t\t6 : Medias\n
1 : International\t\t\t7 : Rendez-vous\n
2 : Europe\t\t\t\t8 : Sports\n
3 : Livres\t\t\t\t9 : Opinions\n
4 : Cinema\t\t\t\t10 : Planete\n
5 : Technologies\t\t\t11 : Voyages\n";

# Rcupration de l'identifiant de la rubrique tap par l'utilisateur
$id = <STDIN>;
# Suppression du dernier caractre de retour  la ligne s'il y en a un
chomp($id);

# Choix de la rubrique
if ($id eq 0) {$num="3208";}
elsif ($id eq 1) {$num="3210";}
elsif ($id eq 2) {$num="3214";}
elsif ($id eq 3) {$num="3260";}
elsif ($id eq 4) {$num="3476";}
elsif ($id eq 5) {$num="651865";}
elsif ($id eq 6) {$num="3236";}
elsif ($id eq 7) {$num="3238";}
elsif ($id eq 8) {$num="3242";}
elsif ($id eq 9) {$num="3232";}
elsif ($id eq 10) {$num="3244";}
elsif ($id eq 11) {$num="3546";}
else { print "Hum... Je n'ai pas compris : je traiterai donc la rubrique 'A la Une'\n"; $num="3208"; }


# Stockage des chemins & noms des diffrentes sorties
my $outputxml="SORTIE_$num.xml";
my $outputtxt="SORTIE_$num.txt";
my $outputlexico="SORTIE_formatlexico3_$num.txt";
my $outputtmp="SORTIE_txtbaliseTreeTagger_$num.txt";
my $outputtmp2="SORTIE_txtbaliseCordial_$num.txt";
# Ouverture des fichiers de sortie (prcision de l'encodage : Latin-1)
if (!open (OUTPUTXML,">:encoding(iso-8859-1)", "$outputxml")) { die "Pb a l'ouverture du fichier $outputxml"};
if (!open (OUTPUTTXT,">:encoding(iso-8859-1)", "$outputtxt")) { die "Pb a l'ouverture du fichier $outputtxt"};
if (!open (LEXICO,">:encoding(iso-8859-1)", "$outputlexico")) { die "Pb a l'ouverture du fichier $outputlexico"};
if (!open (TMP,">:encoding(iso-8859-1)", "$outputtmp")) { die "Pb a l'ouverture du fichier $outputtmp"};
if (!open (TMP2,">:encoding(iso-8859-1)", "$outputtmp2")) { die "Pb a l'ouverture du fichier $outputtmp2"};


############################################################
# Lancement de la procdure sur l'arborescence de fils RSS #
############################################################
# initialisation du compteur de fichiers et du hash qui contiendra les articles dj extraits
my $i=1;
%DUMPARTICLES;
# le chemin du rpertoire est pass en paramtre
&parcoursarborescencefichiers($rep);


########################
# Cration des sorties #
########################

# Une fois que le parcours des dossiers + traitement des fichiers est termin
# Cration du fichier XML
print OUTPUTXML "<?xml version=\"1.0\" encoding=\"iso-8859-1\" standalone=\"yes\"?>\n";
print OUTPUTXML "<PARCOURS>\n";
print OUTPUTXML "<DESC>Ce fichier contient les titres et les rsums des articles de la rubrique ".$rubrique." des fils RSS du journal Le Monde ".$annee."</DESC>\n";
print OUTPUTXML "<FILTRAGE rubrique=\"".$rubrique."\" identifiant=\"$num\">\n".$DUMPXML."</FILTRAGE>\n";
print OUTPUTXML "</PARCOURS>\n";
close(OUTPUTXML);

# Cration du fichier texte
print OUTPUTTXT "$DUMPTXT";
close (OUTPUTTXT);

# sortie au format lexico3 (balises/"cls" spcifiques, format texte)
print LEXICO "<filrss_rubrique=".$num.">\n\n";
print LEXICO "$DUMPLEXICO";
close(LEXICO);

# sortie temporaire pour TreeTagger
print TMP "<$rubrique>\n\n";
print TMP "$DUMPTMP";
close(TMP);

# sortie temporaire pour Cordial
print TMP2 "LIGNEDERUBRIQUE \n\n";
print TMP2 "$DUMPTMP2";
close(TMP2);

#########################################################
# Lancement de la procdure d'tiquetage par Treetagger #
#########################################################
&lancetreetagger;

# procdures d'extraction des patrons avec xslt
# &extractionxslt_NA
# &extractionxslt_NPN


######################
# Fin du programme ! #
######################
exit;


#----------------------------------------------
##############
# PROCEDURES #
##############

# Procdure parcoursarborescencefichiers
sub parcoursarborescencefichiers {
	
	# @_ ('tableau spcial') contient l'ensemble des arguments passs en paramtre  la procdure (ici, un seul)
	# la fonction 'shift' extrait le premier lment du tableau et en renvoie sa valeur, stocke ici sous $path
	my $path = shift(@_);
	# Ouverture du rpertoire contenu dans variable $path 
    opendir(DIR, $path) or die "Problme  l'ouverture de $path: $!\n";
	# lecture et stockage du contenu du rpertoire dans @files
    my @files = readdir(DIR);
	# fermeture du rpertoire
    closedir(DIR);

# Note :  la premire itration, l'argument pass en paramtre est $rep, cd le chemin du rpertoire  parcourir
# @files ne contient alors que les premiers lments de l'arborescence => ici des dossiers avec les noms des mois
# Il faut donc au moins 4 itrations pour avoir accs aux fichiers effectifs et les stocker sous @files : (corpus/)mois/jour/heure/filRSS.xml

# ---------------
	# on trie le contenu de @files (dossiers ou fichiers) alphabtiquement/ordinalement (ici, seulement les dossiers "mois" posent problme)
	# de cette faon, l'extraction et l'criture en sortie du contenu des fils RSS se fera dans l'ordre mois/jour/heure
	@files = sort par_num @files;
	
    foreach my $file (@files) {
	# passe au fichier suivant si jamais le nom du fichier est . ou .. (fichiers systme)
	next if $file =~ /^\.\.?$/;
	# modification du fichier tudi pour que son nom indique clairement l'arborescence
	# concatnation => nom de $file est en ralit $path + $file
	$file = $path."/".$file;
	# si $file contient en ralit un rpertoire (-d, directory)
	# on relance la procdure, avec comme argument $file pour qu'il le parcourt galement
	if (-d $file) {
	    &parcoursarborescencefichiers($file);	
	}
	
	# initialisation d'un compteur pour numroter les articles du fichier
	my $j=1;
	# si l'argument pass $file est de type fichier (et non pas un fichier systme . ou ..) 
	# et que c'est un fichier RSS contenant le numro de la rubrique  traiter
	if ((-f $file) && ($file =~ /0,2-$num,1-0,0\.xml$/)) {
		# on l'ouvre en prcisant l'encodage en UTF-8
		open(FICHIER, "<:encoding(utf-8)", "$file") or die "Le fichier de la rubrique choisie est introuvable...\n";
		# Indication pour l'utilisateur
		print "Ouverture du fichier $file\n";
		
		# On rcupre le nom du fichier en vue de l'inscrire dans le tableau des rsultats et qu'il y ait une ligne par fichier tagg
		if ($file =~ /.+(2009.+0,2-$num,1-0,0\.xml)$/) {
			$file=$1;
		}
		$DUMPTMP .= "<$file>\n";
		$DUMPTMP2 .= "DEBUTDEFICHIER \n";
		
		# parcours du fichier RSS ligne  ligne
		while ($ligne = <FICHIER>) {
			# Rcupration du nom de la rubrique
			if ($ligne =~ /<channel><title>(.*?Le Monde\.fr.*?)<\/title><link>/) {
				$rubrique = $1;
			}
			# Rcupration de la date de l'article
			if ($ligne =~ /<lastBuildDate>(.+200.).+\ ?<\/lastBuildDate>/) {
				$date = $1;
				# rcupration de l'anne pour la balise <DESC> de la sortie xml
				if ($date =~ /.*(\d+)\s(\w+)\s(20\d\d).*/) {
					$jour=$1;
					$mois=$2;
					$annee=$3;
				}
				$DUMPXML.="<FICHIER num=\"$i\" date=\"$date\">\n";
				$DUMPLEXICO .= "<num_fichier=$i nom_fichier=$file jour=$jour mois=$mois annee=$annee>\n";
			}
			# sparation par un saut de ligne si deux balises se trouvent sur la mme ligne
			# (supprime l'ambigut d'extraction du contenu des balises voulues)
			$ligne =~ s/></>\n</g;
			$texte .= $ligne;
			}
		
		# Formatage du texte
			$texte =~ s/\n/\ /g;
			$texte =~ s/\s/\ /g;
			$texte =~ s/\ \ +/\ /g;
			$texte =~ s/</\</g;
			$texte =~ s/>/\>/g;
			$texte =~ s/"/\"/g;
			$texte =~ s//e/g;
			$texteformate = HTML::Entities::decode($texte); # Remplacement des entits HTML
			# Remplacement de certaines entits ncessaire pour certaines rubriques
			$texteformate =~ s/&#39;/\'/g;
			$texteformate =~ s/&#34;/\"/g;
			# on supprime les appels  lire la suite de l'article
			$texteformate =~ s/\[suite\.\.\.\]//gi;
			
			# Rcupration du titre et du rsum, contenus  l'intrieur de chaque balise <item>
			while ($texteformate =~ /<item>\ <title>(.+?)<\/title>.+?<description>(.+?)<\/description>/g) {
				$titre = $1;
				$resume = $2;
			
			# Formatage du titre
				chomp($titre);
				$titre = HTML::Entities::decode($titre); # Remplacement des entits HTML
				$titre =~ s/&/et/g; # remplacement des caractres spciaux
				$titre =~ s/<.+>//g; # suppression des balises s'il y en a
				
				# on ajoute des points  la fin de chaque titre afin d'viter un tiquetage "contextuel" entre la fin du titre et le dbut du rsum
				if ($titre !~ /[!\?\.] *$/) {
					$titre .= "\.";
				}
				# ponctuation : si le dernier caractre du titre est un chiffre, mettre un espace entre le chiffre et le point 
				# (sinonTTagger considre que c'est une abrviation...)
				$titre =~ s/(\d)\./$1 \./g;
			
			# Formatage du rsum
				chomp($resume);
				$resume = HTML::Entities::decode($resume);	# Remplacement des entits HTML
				$resume =~ s/&/et/g;	# remplacement des caractres spciaux
				$resume =~ s/<.+>//g;	# suppression des balises s'il y en a
				
				# ponctuation : si le dernier caractre du rsum est un chiffre, mettre un espace entre le chiffre et le point 
				$resume =~ s/(\d)\./$1 \./g;
				
				# Si le rsum ne contient que la phrase ci-dessous, on ne rcupre rien et on crit une balise auto-fermante <RESUME/>
				# (pour le fichier de sortie xml)
				if ($resume =~ /Retrouvez l'ensemble des dpches sur http:\/\/www.lemonde.fr/) {
					$resume = "<RESUME/>";
					$resumetxt = "";
				}
				# Si le rsum est vide, on crit une balise auto-fermante <RESUME/>
				elsif ($resume =~ /^ *$/) {
					$resume = "<RESUME/>";
					$resumetxt = "";
				}
				# Dans tous les autres cas, on a un contenu potentiellement exploitable :
				else {
					# si le rsum ne se termine pas par un point, on en rajoute un 
					# (but double : pas d'tiquetage contextuel et sparation par phrase dans le tableau des rsultats)
					if ($resume !~ /[!\?\.] *$/) {
						$resume .= "\.";
					}
					$resumetxt = $resume;
					$resume = "<RESUME>$resume<\/RESUME>";
				}
				
				# Filtrage des doublons d'articles 
				#(pas d'ajout si le titre est dj prsent dans le hash %DUMPARTICLES, contenant les titres des contenus dj extraits)
				unless (exists $DUMPARTICLES{$titre}) {
					$DUMPXML.="<ARTICLE num=\"$j\">\n<TITRE>$titre<\/TITRE>\n$resume\n<\/ARTICLE>\n";
					$DUMPTXT.="$titre $resumetxt\n";
					$DUMPTMP.="<BLOC> $titre <BLOC> $resumetxt\n";
					$DUMPTMP2.="BLOCDEPHRASE $titre BLOCDEPHRASE $resumetxt \n";
					$DUMPLEXICO.="<num_article=$j>\n<titre_num_article=$j>\n$titre\n\n<resume_num_article=$j>\n$resumetxt\n\n\n";
					
					# Incrmentation du compteur d'articles
					$j++;
					# Ajout dans le hash %DUMPARTICLES du titre du rsum venant d'tre extrait, pour le filtrage
					$DUMPARTICLES{$titre}++;
				}
			}
			# Incrmentation du compteur de fichiers
			$i++;
			# Fermeture de la balise </FICHIER> dans le fichier XML
			$DUMPXML.="<\/FICHIER>\n";
			# saut de ligne pour le tableau des rsultats
			$DUMPTMP.="\n";
			$DUMPTMP2.="\n";
			# passage au fichier suivant (# recurse!)
			close(FICHIER);
			# ... en vidant au pralable la variable $texte
			$texte = "";
			
		}
	}
}
# Procdure d'tiquetage Treetagger
sub lancetreetagger {
	system("perl TreeTagger/tokenise-fr.pl $outputtmp | tree-tagger TreeTagger/french.par -lemma -token -no-unknown -sgml > treetagger.txt");
}

# Procdure de tri alphabtique
sub par_num { return $a <=> $b }